{*************************************************************}
{              KDatabase Export pack version 1.00             }
{               Copyright  2000 Korzh company                }
{                http://www.korzh.com/delphi/                 }
{                  mailto:delphi@korzh.com                    }
{-------------------------------------------------------------}
{                   TKDataSetToDBF component                  }
{                  last updated: Mar-16-2000                  }
{*************************************************************}
unit kds2dbf;

interface
uses Classes, SysUtils, DB, DBTables;

type
  TKDataSetToDBF = class(TComponent)
  private
    FDataSet : TDataSet;
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation);override;
  public
    constructor Create(AOwner : TComponent);override;
    destructor Destroy; override;
    procedure Transfer(const TableFileName : string);
  published
    property DataSet : TDataSet read FDataSet write FDataSet;
  end;


implementation

constructor TKDataSetToDBF.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FDataset := nil;
end;

destructor TKDataSetToDBF.Destroy;
begin
  inherited;
end;

procedure TKDataSetToDBF.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = FDataSet) then
    FDataSet := nil;
end;

procedure TKDataSetToDBF.Transfer(const TableFileName : string);
var
  Table : TTable;
  BM : TBatchMove;
begin
  Table := TTable.Create(nil);
  try
    Table.TableType := ttDBase;
    Table.DatabaseName := ExtractFileDir(TableFileName);
    Table.TableName := ExtractFileName(TableFileName);
    BM := TBatchMove.Create(nil);
    try
      BM.Mode := batCopy;
      BM.Source := TBDEDataSet(FDataset);
      BM.Destination := Table;
      BM.Execute;
    finally
      BM.Free;
    end;
  finally
    Table.Free;
  end;
end;


end.
